#! /bin/sh
set -e

VERSION=src/autoversion.h
export LC_ALL=C
export LANGUAGE=C
export LANG=C
export CHARSET="iso8859-1"

if [ -f $VERSION ]; then
	echo "Recreating autoversion.h"
	rm $VERSION
else
	echo "Creating autoversion.h"
fi

#get path to gamedata provided my make
BUILD_DATADIR=$1

#get svn version if we have any
BUILD_REVISION="unknown"
BUILD_SVNURL="unknown"
cd ./src
if [ -d .svn ]; then
	echo "Found .svn in src"
	BUILD_REVISION=`svn info | grep vision | awk -F': ' '{print $NF}'`
	BUILD_SVNURL=`svn info | grep URL | awk -F': ' '{print $NF}'`
else
	echo "Couldn't read svn info from src/.svn"
fi
cd ../

#get date
BUILD_DATE=`LANG=en_EN date +"%b %m %Y %T"`
#get some more informations about host
BUILD_UNAME_A=`uname -a`
BUILD_UNAME_M=`uname -m`
BUILD_UNAME_N=`uname -n`
BUILD_UNAME_R=`uname -r`
BUILD_UNAME_S=`uname -s`
BUILD_UNAME_V=`uname -v`
BUILD_UNAME_SRM=`uname -srm`
BUILD_USER=`whoami`

cat > "$VERSION" << EOF
/***************************************************************************
 *      Mechanized Assault and Exploration Reloaded Projectfile            *
 *                                                                         *
 *   autoversion.h - Generated by buildinfo.sh.                            *
 *                                                                         *
 *   This is an automatically generated file. Do not modify this file,     *
 *   changes will be lost the next time make gets invoked!                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define HAVE_AUTOVERSION_H 1

#ifdef RELEASE
#	define PACKAGE_REV "Releaseversion"
#else
#	define PACKAGE_REV "SVN Rev $BUILD_REVISION"
#endif

#define BUILD_SVNURL "$BUILD_SVNURL"
#define BUILD_DATADIR "$BUILD_DATADIR"
#define MAX_BUILD_DATE "$BUILD_DATE"
#define BUILD_UNAME_A "$BUILD_UNAME_A"
#define BUILD_UNAME_M "$BUILD_UNAME_M"
#define BUILD_UNAME_N "$BUILD_UNAME_N"
#define BUILD_UNAME_R "$BUILD_UNAME_R"
#define BUILD_UNAME_S "$BUILD_UNAME_S"
#define BUILD_UNAME_V "$BUILD_UNAME_V"
#define BUILD_UNAME_SRM "$BUILD_UNAME_SRM"
#define BUILD_USER "$BUILD_USER"
EOF
